	#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
using System.IO;
using System.Collections.Generic;
using System.Media;
using System.Globalization;
using System.Text;
using System.Net.Mail;
using System.Net;
using System.Linq;
using System.Windows.Forms;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Enter the description of your new custom indicator here
    /// </summary>
    [Description("Enter the description of your new custom indicator here")]
    public class CustomTicks : Indicator
    {
       #region Variables
        // Wizard generated variables
            private int myInput0 = 1; // Default setting for MyInput0
        // User defined variables (add any user defined variables below)\
		DateTime endTime;
		DateTime startTime;
		string tick_time;
		int part_vol = 5;
		int sum_vol_limit = 150;
		int fix_period = 2;
		int vol_count = 1;
		List<DateTime> main_DT = new List<DateTime>();
		List<int> main_Vol = new List<int>();
		List<double> main_Pr = new List<double>();
		double ell_xr;
		double ell_xr_txt;
		int buff_tag =1;
		double price_buff=0;
		Label Banner =new Label();
		private Color text_color=Color.Black;
		private Color indicator_color=Color.Red;
		int price_range = 5;
		int k=10;
        int vol = 0;
		string v = "";
		int summ =0;  
		int font_size=8;
		
		string time_from = "00:00";
		string time_to = "23:59";
		
		int h_from, m_from, h_to, m_to;
		bool playsignal = true;
		
		double large_tick=50;
		
		private TypeShape type_Visual=TypeShape.Circle;
		
		
		private TypeOfInfo info_type=TypeOfInfo.Short;
		
		//bool only_summ = false;
		
		private List<Ellipse> ListOfEllipse = new List<Ellipse>();
		
        #endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
           // Add(new Plot(Color.FromKnownColor(KnownColor.Orange), PlotStyle.Line, "Plot0"));
		
			Add(PeriodType.Tick, 1);
            Overlay				= true;
				
			
			Banner.Location = new Point(0,16);
			Banner.Size = new Size(100, 13);
			//Font fn=new Font("Arial",Color.Blue);
			Banner.ForeColor=Color.Blue;
			Banner.Text = "mastersofrisk.com";
			Banner.Click += new EventHandler(Banner_Click); //assign click handler
			Banner.BackColor=ChartControl.BackColor;
			ChartControl.ChartPanel.Controls.Add(Banner);
        }
		
		protected void Banner_Click(object sender, EventArgs e)
		{
			Process.Start("https://mastersofrisk.com/shop/");
		}
		
		protected override void OnStartUp()
        {
           ell_xr =TickSize*3;
		   ell_xr_txt =TickSize*3;
			
			string[] spl_time = time_from.Split(':');
				//Print(spl_time[0]+"////"+spl_time[1]);
				h_from = Convert.ToInt32(spl_time[0]);
				m_from = Convert.ToInt32(spl_time[1]);
				
				spl_time = time_to.Split(':');
				h_to = Convert.ToInt32(spl_time[0]);
				m_to = Convert.ToInt32(spl_time[1]);
				
        }
        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
             
			if(BarsInProgress==1){
				MarketElement market = new MarketElement();
				market.Price=Opens[1][0];
				market.Time=Times[1][0];
				market.Volume=Volumes[1][0];
				HistoryDraw(market);
				//draw_tick_history();
			}
			
        }
		protected override void OnTermination()
		{
			ChartControl.ChartPanel.Controls.Remove(Banner);
		}
		
		public override void Plot(Graphics graphics, Rectangle bounds, double min, double max){
			int h=ChartControl.GetYByValue(this,max)-ChartControl.GetYByValue(this,max+TickSize);
			SolidBrush colorBrush = new SolidBrush(indicator_color);
			colorBrush.Color=Color.FromArgb(100,indicator_color);
			//SolidBrush br = new SolidBrush(Color.Blue);
			//graphics.DrawString("mastersofrisk.com",new Font("Arial",10),br,0,16);
			Font drawFont = new Font("Arial", font_size);
			SolidBrush drawBrush = new SolidBrush(text_color);
			for(int i=0;i<ListOfEllipse.Count;i++){
				//Print(ListOfEllipse[i].Time+"    "+ListOfEllipse[i].Volume_sum);
				
				DateTime t =ListOfEllipse[i].Time;
					if(ListOfEllipse[i].MaxTick>=large_tick){
						switch(type_Visual){
							case TypeShape.Circle:{
											int X=ChartControl.GetXByTime(ListOfEllipse[i].Time);
											int Y=ChartControl.GetYByValue(this,ListOfEllipse[i].PriceStart);
											double tmp=ListOfEllipse[i].Volume_sum/(200/k)*h;
											int d=(int)tmp;
											int r=d/2;
											graphics.FillEllipse(colorBrush,X-r,Y-r,d,d);
											string info_short=ListOfEllipse[i].text;
											string info_large;
										
												if(ListOfEllipse[i].Range==1){
													info_large=ListOfEllipse[i].Volume_sum.ToString()+"/"+t.ToString("dd.MM.yy")+"/"+t.ToString("hh:mm")+"/"+"1:1";
												}else{
													info_large=ListOfEllipse[i].Volume_sum+"/"+t.ToString("dd.MM.yy")+"/"+t.ToString("hh:mm")+"/"+ListOfEllipse[i].PriceStart+"-"+ListOfEllipse[i].PriceEnd+":"+ListOfEllipse[i].Range;
												}		
												
												switch(info_type){
													case TypeOfInfo.Short:graphics.DrawString(ListOfEllipse[i].Volume_sum.ToString(),drawFont,drawBrush,X-r,Y-r-h);break;
													case TypeOfInfo.Large:graphics.DrawString(info_large,drawFont,drawBrush,X-r,Y-r-h);break;
													case TypeOfInfo.Full:{
																graphics.DrawString(info_large,drawFont,drawBrush,X-r,Y-r-h*4);
																graphics.DrawString(info_short,drawFont,drawBrush,X-r,Y-r-h);
																}break;
							
												}
							
							}break;
							case TypeShape.Square:{
											int X=ChartControl.GetXByTime(ListOfEllipse[i].Time);
											int Y=ChartControl.GetYByValue(this,ListOfEllipse[i].PriceStart);
											int range=ListOfEllipse[i].Range;
											if(range==0)range=1;
											int Y1=range*h;
											int tmp=(int)ListOfEllipse[i].Volume_sum/(400/k)*h;
											graphics.FillRectangle(colorBrush,X,Y,tmp,Y1);
											string info_short=ListOfEllipse[i].text;
											string info_large;
										
												if(ListOfEllipse[i].Range==1){
													info_large=ListOfEllipse[i].Volume_sum.ToString()+"/"+t.ToString("dd.MM.yy")+"/"+t.ToString("hh:mm")+"/"+"1:1";
												}else{
													info_large=ListOfEllipse[i].Volume_sum+"/"+t.ToString("dd.MM.yy")+"/"+t.ToString("hh:mm")+"/"+ListOfEllipse[i].PriceStart+"-"+ListOfEllipse[i].PriceEnd+":"+ListOfEllipse[i].Range;
												}		
												
												switch(info_type){
													case TypeOfInfo.Short:graphics.DrawString(ListOfEllipse[i].Volume_sum.ToString(),drawFont,drawBrush,X,Y-h*4);break;
													case TypeOfInfo.Large:graphics.DrawString(info_large,drawFont,drawBrush,X,Y-h*4);break;
													case TypeOfInfo.Full:{
																graphics.DrawString(info_large,drawFont,drawBrush,X,Y-h*7);
																graphics.DrawString(info_short,drawFont,drawBrush,X,Y-h*4);
																}break;
							
												}
							
							}break;
						}
					}
				}
		}
		
		private void HistoryDraw(MarketElement e)
		{
 				int vol = Convert.ToInt32(e.Volume);
				double price = e.Price;
				if (vol>=part_vol)
						{
							
									
							DateTime dt_tick_time =new DateTime(e.Time.Year, e.Time.Month,e.Time.Day,e.Time.Hour, e.Time.Minute, e.Time.Second);
							
							DateTime fr_time = new DateTime(dt_tick_time.Year, dt_tick_time.Month, dt_tick_time.Day, h_from, m_from, 0);
							DateTime to_time = new DateTime(dt_tick_time.Year, dt_tick_time.Month, dt_tick_time.Day, h_to, m_to, 0);
							
							if (main_DT.Count==0)
							{main_DT.Add(dt_tick_time); main_Vol.Add(vol);main_Pr.Add(price);}
							else
							{
								TimeSpan t_span = dt_tick_time - main_DT[main_DT.Count-1];
								double sec = t_span.TotalSeconds;
								
								if (sec<=fix_period)
								{
									//Print(e.Time);
									main_DT.Add(dt_tick_time); main_Vol.Add(vol);main_Pr.Add(price);
									main_Pr.Sort();
									if (main_Pr[main_Pr.Count-1] - main_Pr[0] <=(price_range*TickSize))
									{
										if (main_Vol.Count>=vol_count)
										{
											
											endTime = dt_tick_time;//.AddMinutes(5);
											startTime =dt_tick_time;//.AddMinutes(-5);
									   		Dictionary<double,int> agregation = new Dictionary<double,int>();
										
											
											for(int x =0;x<main_Vol.Count;x++)
											{
											
												summ+=main_Vol[x];
												if(agregation.ContainsKey(main_Vol[x])){
													int tmp=0;
													agregation.TryGetValue(main_Vol[x],out tmp);
													//Print(tmp);
													agregation[main_Vol[x]]++;
												}else{
													agregation.Add(main_Vol[x],1);
												}
											//	el.ListTickVolumes.Add(main_Vol[x]);
												
											}
											
										
										if (summ>=sum_vol_limit && dt_tick_time>=fr_time && dt_tick_time<to_time)
										{
											var list=agregation.Keys.ToList();
											list.Sort();
											list.Reverse();
											string v1="";//summ+"=";
                                       		//Print(list[0]);
											foreach(var key in list)
											{
												
												if(agregation[key]==1){
													v1+=key.ToString()+"+";
												}else{
													v1+=key.ToString()+"*"+agregation[key]+"+";
												}
											}
											
											
											v1=v1.Remove(v1.Length-1,1);
												double tmp1=Math.Abs(main_Pr[main_Pr.Count-1] - main_Pr[0])/TickSize;
											//Print(startTime+"   "+(int)tmp1);
											dr_ell(v1,(int)tmp1,main_Pr[main_Pr.Count-1],main_Pr[0],list[0]);
											
										}
										v=""; 
										summ = 0;
										}
										
										
									}
									else
									{
										main_DT.Clear(); main_Vol.Clear(); main_Pr.Clear();
										main_DT.Add(dt_tick_time); main_Vol.Add(vol);main_Pr.Add(price);
										
										buff_tag++;
										v=""; 
										summ = 0;
									}
									
									
								}
								else if (sec>fix_period)
								{
								main_DT.Clear(); main_Vol.Clear(); main_Pr.Clear();
								main_DT.Add(dt_tick_time); main_Vol.Add(vol);main_Pr.Add(price);
								
								buff_tag++;
								v=""; summ = 0;
								}
							
								
							}
					
						}
				
		}
			

		private void dr_ell(string v,int range, double priceStart,double priceEnd,double maxtick)
		{
			
			if(ListOfEllipse.Count==0){
				Ellipse el = new Ellipse();
				el.Volume_sum=summ;
				//el.Price=price;
				el.Time=startTime;
				el.Tag=buff_tag;
				el.text=v;
				el.Range=range;
				el.PriceStart=priceStart;
				el.PriceEnd=priceEnd;
				el.MaxTick=maxtick;
				ListOfEllipse.Add(el);
				return;
			}
			if(buff_tag==ListOfEllipse[ListOfEllipse.Count-1].Tag){
				ListOfEllipse[ListOfEllipse.Count-1].Volume_sum=summ;
				//ListOfEllipse[ListOfEllipse.Count-1].Price=price;
				ListOfEllipse[ListOfEllipse.Count-1].Time=startTime;
				ListOfEllipse[ListOfEllipse.Count-1].Tag=buff_tag;
				ListOfEllipse[ListOfEllipse.Count-1].text=v;
				ListOfEllipse[ListOfEllipse.Count-1].Range=range;
				ListOfEllipse[ListOfEllipse.Count-1].PriceStart=priceStart;
				ListOfEllipse[ListOfEllipse.Count-1].PriceEnd=priceEnd;
				ListOfEllipse[ListOfEllipse.Count-1].MaxTick=maxtick;
			}
			if(buff_tag>ListOfEllipse[ListOfEllipse.Count-1].Tag){
				Ellipse el = new Ellipse();
				el.Volume_sum=summ;
				//el.Price=price;
				el.Time=startTime;
				el.Tag=buff_tag;
				el.text=v;
				el.Range=range;
				el.PriceStart=priceStart;
				el.PriceEnd=priceEnd;
				el.MaxTick=maxtick;
				ListOfEllipse.Add(el);
			}
		}
	
		private class Ellipse
		{
			public double Volume_sum{get;set;}
			public double PriceStart{get;set;}
			public double PriceEnd{get;set;}
			public int Tag{get;set;}
			public double MaxTick{get;set;}
			public int Range{get;set;}
			public string text{get;set;}
			public DateTime Time{get;set;}
			public List<double> ListTickVolumes=new List<double>();
			public void Sort(){
				
			}
		}
		private class MarketElement
		{
			public double Volume{get;set;}
			public double Price{get;set;}
			public DateTime Time{get;set;}
		}

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Plot0
        {
            get { return Values[0]; }
        }

       [Description("Minimum Tick volume, should be 1 or bigger, ticks.")]
        [GridCategory("1. Data")]
		[Gui.Design.DisplayName("1. Tick volume")]
        public int C_Part_vol
        {
            get { return part_vol; }
            set { part_vol = Math.Max(1, value); }
        }
		[Description("Minimum Summary limit, ticks")]
        [GridCategory("1. Data")]
		[Gui.Design.DisplayName("2. Summ tick volume")]
        public int C_SUM_vol_limit
        {
            get { return sum_vol_limit; }
            set { sum_vol_limit = Math.Max(1, value); }
        }
		[XmlIgnore()]
		[Description("Circle color")]
        [GridCategory("2. Style")]
		[Gui.Design.DisplayName("1. Color")]
        public Color Indicator_color
        {
            get { return indicator_color; }
            set { indicator_color = value; }
        }
		public string Indicator_colorSerialize
		{
			get { return NinjaTrader.Gui.Design.SerializableColor.ToString(indicator_color); }
			set { indicator_color = NinjaTrader.Gui.Design.SerializableColor.FromString(value); }
		}
		
		[XmlIgnore()]
		[Description("Circle color")]
        [GridCategory("2. Style")]
		[Gui.Design.DisplayName("2. Text Color")]
        public Color Text_color
        {
            get { return text_color; }
            set { text_color = value; }
        }
		public string Text_colorSerialize
		{
			get { return NinjaTrader.Gui.Design.SerializableColor.ToString(text_color); }
			set { text_color = NinjaTrader.Gui.Design.SerializableColor.FromString(value); }
		}
		
		
		[Description("Minimum ticks amount in the chain, should be 1 or bigger, ticks.")]
        [GridCategory("1. Data")]
		[Gui.Design.DisplayName("5. Ticks amount")]
        public int C_tick_count
        {
            get { return vol_count; }
            set { vol_count = value; }
        }
		[Description("Delay between ticks, sec.")]
        [GridCategory("1. Data")]
		[Gui.Design.DisplayName("3. Delay, sec.")]
        public int C_fix_period
        {
            get { return fix_period; }
            set { fix_period = value; }
        }
		[Description("Circle radius ratio")]
        [GridCategory("2. Style")]
		[Gui.Design.DisplayName("2. Box/Circle size")]
        public int Ellipse_radius
        {
            get { return k; }
            set { k = value; }
        }
		[Description("Range between prices, should be 1 or bigger, ticks")]
        [GridCategory("1. Data")]
		[Gui.Design.DisplayName("4. Price range")]
        public int C_price_range
        {
            get { return price_range; }
            set { price_range = value; }
        }
		[Description("Time when to start HH:MM")]
        [GridCategory("1. Data")]
		[Gui.Design.DisplayName("6. Start Time")]
        public string C_TIME_FROM
        {
            get { return time_from; }
            set { time_from = value; }
        }
		[Description("Time when to end HH:MM")]
        [GridCategory("1. Data")]
		[Gui.Design.DisplayName("7. End Time")]
        public string C_TIME_TO
        {
            get { return time_to; }
            set { time_to = value; }
        }
		[Description("Play sound True/False")]
        [GridCategory("2. Style")]
		[Gui.Design.DisplayName("4. Alert")]
        public bool C_play_signal
        {
            get { return playsignal; }
            set { playsignal = value; }
        }
		[Description("Info Font Size")]
        [GridCategory("2. Style")]
		[Gui.Design.DisplayName("3. Font Size")]
        public int Font_size
        {
            get { return font_size; }
            set { font_size = value; }
        }
		 [Description("Info: Short - Volume only, Large - Volume/Date/Time/Price1-Price2:Range, Full - same as Large + tick chain volumes")]
        [GridCategory("1. Data")]
		[Gui.Design.DisplayName("8. Info type")]
        public TypeOfInfo TypeInfo
        {
            get { return info_type; }
            set { info_type = value; }
        }
		
		[Description("Filter to find tick=> in ticks chain, should be => Tick volume")]
        [GridCategory("1. Data")]
		[Gui.Design.DisplayName("9. Large Tick")]
        public double Large_tick
        {
            get { return large_tick; }
            set { large_tick = value; }
        }
		
		[Description("")]
        [GridCategory("2. Style")]
		[Gui.Design.DisplayName("4. Shape type")]
        public TypeShape Typeshape
        {
            get { return type_Visual; }
            set { type_Visual = value; }
        }
        #endregion
    }
}
public enum TypeOfInfo
{
	Short,
	Large,
	Full,
	None,
}
public enum TypeShape
{
	Circle,
	Square
}
#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private CustomTicks[] cacheCustomTicks = null;

        private static CustomTicks checkCustomTicks = new CustomTicks();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public CustomTicks CustomTicks(int c_fix_period, int c_Part_vol, bool c_play_signal, int c_price_range, int c_SUM_vol_limit, int c_tick_count, string c_TIME_FROM, string c_TIME_TO, int ellipse_radius, int font_size, Color indicator_color, double large_tick, Color text_color, TypeOfInfo typeInfo, TypeShape typeshape)
        {
            return CustomTicks(Input, c_fix_period, c_Part_vol, c_play_signal, c_price_range, c_SUM_vol_limit, c_tick_count, c_TIME_FROM, c_TIME_TO, ellipse_radius, font_size, indicator_color, large_tick, text_color, typeInfo, typeshape);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public CustomTicks CustomTicks(Data.IDataSeries input, int c_fix_period, int c_Part_vol, bool c_play_signal, int c_price_range, int c_SUM_vol_limit, int c_tick_count, string c_TIME_FROM, string c_TIME_TO, int ellipse_radius, int font_size, Color indicator_color, double large_tick, Color text_color, TypeOfInfo typeInfo, TypeShape typeshape)
        {
            if (cacheCustomTicks != null)
                for (int idx = 0; idx < cacheCustomTicks.Length; idx++)
                    if (cacheCustomTicks[idx].C_fix_period == c_fix_period && cacheCustomTicks[idx].C_Part_vol == c_Part_vol && cacheCustomTicks[idx].C_play_signal == c_play_signal && cacheCustomTicks[idx].C_price_range == c_price_range && cacheCustomTicks[idx].C_SUM_vol_limit == c_SUM_vol_limit && cacheCustomTicks[idx].C_tick_count == c_tick_count && cacheCustomTicks[idx].C_TIME_FROM == c_TIME_FROM && cacheCustomTicks[idx].C_TIME_TO == c_TIME_TO && cacheCustomTicks[idx].Ellipse_radius == ellipse_radius && cacheCustomTicks[idx].Font_size == font_size && cacheCustomTicks[idx].Indicator_color == indicator_color && Math.Abs(cacheCustomTicks[idx].Large_tick - large_tick) <= double.Epsilon && cacheCustomTicks[idx].Text_color == text_color && cacheCustomTicks[idx].TypeInfo == typeInfo && cacheCustomTicks[idx].Typeshape == typeshape && cacheCustomTicks[idx].EqualsInput(input))
                        return cacheCustomTicks[idx];

            lock (checkCustomTicks)
            {
                checkCustomTicks.C_fix_period = c_fix_period;
                c_fix_period = checkCustomTicks.C_fix_period;
                checkCustomTicks.C_Part_vol = c_Part_vol;
                c_Part_vol = checkCustomTicks.C_Part_vol;
                checkCustomTicks.C_play_signal = c_play_signal;
                c_play_signal = checkCustomTicks.C_play_signal;
                checkCustomTicks.C_price_range = c_price_range;
                c_price_range = checkCustomTicks.C_price_range;
                checkCustomTicks.C_SUM_vol_limit = c_SUM_vol_limit;
                c_SUM_vol_limit = checkCustomTicks.C_SUM_vol_limit;
                checkCustomTicks.C_tick_count = c_tick_count;
                c_tick_count = checkCustomTicks.C_tick_count;
                checkCustomTicks.C_TIME_FROM = c_TIME_FROM;
                c_TIME_FROM = checkCustomTicks.C_TIME_FROM;
                checkCustomTicks.C_TIME_TO = c_TIME_TO;
                c_TIME_TO = checkCustomTicks.C_TIME_TO;
                checkCustomTicks.Ellipse_radius = ellipse_radius;
                ellipse_radius = checkCustomTicks.Ellipse_radius;
                checkCustomTicks.Font_size = font_size;
                font_size = checkCustomTicks.Font_size;
                checkCustomTicks.Indicator_color = indicator_color;
                indicator_color = checkCustomTicks.Indicator_color;
                checkCustomTicks.Large_tick = large_tick;
                large_tick = checkCustomTicks.Large_tick;
                checkCustomTicks.Text_color = text_color;
                text_color = checkCustomTicks.Text_color;
                checkCustomTicks.TypeInfo = typeInfo;
                typeInfo = checkCustomTicks.TypeInfo;
                checkCustomTicks.Typeshape = typeshape;
                typeshape = checkCustomTicks.Typeshape;

                if (cacheCustomTicks != null)
                    for (int idx = 0; idx < cacheCustomTicks.Length; idx++)
                        if (cacheCustomTicks[idx].C_fix_period == c_fix_period && cacheCustomTicks[idx].C_Part_vol == c_Part_vol && cacheCustomTicks[idx].C_play_signal == c_play_signal && cacheCustomTicks[idx].C_price_range == c_price_range && cacheCustomTicks[idx].C_SUM_vol_limit == c_SUM_vol_limit && cacheCustomTicks[idx].C_tick_count == c_tick_count && cacheCustomTicks[idx].C_TIME_FROM == c_TIME_FROM && cacheCustomTicks[idx].C_TIME_TO == c_TIME_TO && cacheCustomTicks[idx].Ellipse_radius == ellipse_radius && cacheCustomTicks[idx].Font_size == font_size && cacheCustomTicks[idx].Indicator_color == indicator_color && Math.Abs(cacheCustomTicks[idx].Large_tick - large_tick) <= double.Epsilon && cacheCustomTicks[idx].Text_color == text_color && cacheCustomTicks[idx].TypeInfo == typeInfo && cacheCustomTicks[idx].Typeshape == typeshape && cacheCustomTicks[idx].EqualsInput(input))
                            return cacheCustomTicks[idx];

                CustomTicks indicator = new CustomTicks();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.C_fix_period = c_fix_period;
                indicator.C_Part_vol = c_Part_vol;
                indicator.C_play_signal = c_play_signal;
                indicator.C_price_range = c_price_range;
                indicator.C_SUM_vol_limit = c_SUM_vol_limit;
                indicator.C_tick_count = c_tick_count;
                indicator.C_TIME_FROM = c_TIME_FROM;
                indicator.C_TIME_TO = c_TIME_TO;
                indicator.Ellipse_radius = ellipse_radius;
                indicator.Font_size = font_size;
                indicator.Indicator_color = indicator_color;
                indicator.Large_tick = large_tick;
                indicator.Text_color = text_color;
                indicator.TypeInfo = typeInfo;
                indicator.Typeshape = typeshape;
                Indicators.Add(indicator);
                indicator.SetUp();

                CustomTicks[] tmp = new CustomTicks[cacheCustomTicks == null ? 1 : cacheCustomTicks.Length + 1];
                if (cacheCustomTicks != null)
                    cacheCustomTicks.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheCustomTicks = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.CustomTicks CustomTicks(int c_fix_period, int c_Part_vol, bool c_play_signal, int c_price_range, int c_SUM_vol_limit, int c_tick_count, string c_TIME_FROM, string c_TIME_TO, int ellipse_radius, int font_size, Color indicator_color, double large_tick, Color text_color, TypeOfInfo typeInfo, TypeShape typeshape)
        {
            return _indicator.CustomTicks(Input, c_fix_period, c_Part_vol, c_play_signal, c_price_range, c_SUM_vol_limit, c_tick_count, c_TIME_FROM, c_TIME_TO, ellipse_radius, font_size, indicator_color, large_tick, text_color, typeInfo, typeshape);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.CustomTicks CustomTicks(Data.IDataSeries input, int c_fix_period, int c_Part_vol, bool c_play_signal, int c_price_range, int c_SUM_vol_limit, int c_tick_count, string c_TIME_FROM, string c_TIME_TO, int ellipse_radius, int font_size, Color indicator_color, double large_tick, Color text_color, TypeOfInfo typeInfo, TypeShape typeshape)
        {
            return _indicator.CustomTicks(input, c_fix_period, c_Part_vol, c_play_signal, c_price_range, c_SUM_vol_limit, c_tick_count, c_TIME_FROM, c_TIME_TO, ellipse_radius, font_size, indicator_color, large_tick, text_color, typeInfo, typeshape);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.CustomTicks CustomTicks(int c_fix_period, int c_Part_vol, bool c_play_signal, int c_price_range, int c_SUM_vol_limit, int c_tick_count, string c_TIME_FROM, string c_TIME_TO, int ellipse_radius, int font_size, Color indicator_color, double large_tick, Color text_color, TypeOfInfo typeInfo, TypeShape typeshape)
        {
            return _indicator.CustomTicks(Input, c_fix_period, c_Part_vol, c_play_signal, c_price_range, c_SUM_vol_limit, c_tick_count, c_TIME_FROM, c_TIME_TO, ellipse_radius, font_size, indicator_color, large_tick, text_color, typeInfo, typeshape);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.CustomTicks CustomTicks(Data.IDataSeries input, int c_fix_period, int c_Part_vol, bool c_play_signal, int c_price_range, int c_SUM_vol_limit, int c_tick_count, string c_TIME_FROM, string c_TIME_TO, int ellipse_radius, int font_size, Color indicator_color, double large_tick, Color text_color, TypeOfInfo typeInfo, TypeShape typeshape)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.CustomTicks(input, c_fix_period, c_Part_vol, c_play_signal, c_price_range, c_SUM_vol_limit, c_tick_count, c_TIME_FROM, c_TIME_TO, ellipse_radius, font_size, indicator_color, large_tick, text_color, typeInfo, typeshape);
        }
    }
}
#endregion
